using System;
using System.Drawing;

namespace RedEyePlugIn
{
    /// <summary>
    /// RedEyePlugIn class is loaded
    /// at run time by the application.
    /// </summary>
    /// <requirements>F:image_special_effects</requirements>
    public class RedEyePlugIn
    {
        /// <summary>
        /// Constructor.
        /// </summary>
        public RedEyePlugIn()
        {
        }
        /// <summary>
        /// ProcessImage method. Invoked by the application.
        /// Red component is reduced to 80% to remove red eyes.
        /// </summary>
        public void ProcessImage(Bitmap sourceImage, 
            int xVal, int yVal, int areaVal)
        {
            Color myColor;
            // Walk through the area of the displayed
            // rectangle within the image.
            for(int i = yVal; i < (yVal + areaVal); ++i)
            {
                for (int j = xVal; j < (xVal + areaVal); ++j)
                {
                    // Get the current pixel
                    myColor = sourceImage.GetPixel(j,i);
                    // Set the red value to 80% of the original value
                    // and keep the other values.
                    sourceImage.SetPixel(j, i, 
                        Color.FromArgb((int)(myColor.R*0.8), 
                        (int)(myColor.G), (int)(myColor.B)));
                }
            }
        }
    }
}

